/*
Authorization Service API v. 1.0

<a href='https://cern.service-now.com/service-portal?id=privacy_policy&se=SSO-Service&notice=resources'>Privacy notice</a>

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package authzapiv1

import (
	"encoding/json"
)

// checks if the IdentityInfo type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &IdentityInfo{}

// IdentityInfo struct for IdentityInfo
type IdentityInfo struct {
	Id          NullableString `json:"id,omitempty"`
	Type        *IdentityType  `json:"type,omitempty"`
	Upn         NullableString `json:"upn,omitempty"`
	DisplayName NullableString `json:"displayName,omitempty"`
	PersonId    NullableString `json:"personId,omitempty"`
	Source      NullableString `json:"source,omitempty"`
}

// NewIdentityInfo instantiates a new IdentityInfo object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewIdentityInfo() *IdentityInfo {
	this := IdentityInfo{}
	return &this
}

// NewIdentityInfoWithDefaults instantiates a new IdentityInfo object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewIdentityInfoWithDefaults() *IdentityInfo {
	this := IdentityInfo{}
	return &this
}

// GetId returns the Id field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *IdentityInfo) GetId() string {
	if o == nil || IsNil(o.Id.Get()) {
		var ret string
		return ret
	}
	return *o.Id.Get()
}

// GetIdOk returns a tuple with the Id field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *IdentityInfo) GetIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Id.Get(), o.Id.IsSet()
}

// HasId returns a boolean if a field has been set.
func (o *IdentityInfo) HasId() bool {
	if o != nil && o.Id.IsSet() {
		return true
	}

	return false
}

// SetId gets a reference to the given NullableString and assigns it to the Id field.
func (o *IdentityInfo) SetId(v string) {
	o.Id.Set(&v)
}

// SetIdNil sets the value for Id to be an explicit nil
func (o *IdentityInfo) SetIdNil() {
	o.Id.Set(nil)
}

// UnsetId ensures that no value is present for Id, not even an explicit nil
func (o *IdentityInfo) UnsetId() {
	o.Id.Unset()
}

// GetType returns the Type field value if set, zero value otherwise.
func (o *IdentityInfo) GetType() IdentityType {
	if o == nil || IsNil(o.Type) {
		var ret IdentityType
		return ret
	}
	return *o.Type
}

// GetTypeOk returns a tuple with the Type field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *IdentityInfo) GetTypeOk() (*IdentityType, bool) {
	if o == nil || IsNil(o.Type) {
		return nil, false
	}
	return o.Type, true
}

// HasType returns a boolean if a field has been set.
func (o *IdentityInfo) HasType() bool {
	if o != nil && !IsNil(o.Type) {
		return true
	}

	return false
}

// SetType gets a reference to the given IdentityType and assigns it to the Type field.
func (o *IdentityInfo) SetType(v IdentityType) {
	o.Type = &v
}

// GetUpn returns the Upn field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *IdentityInfo) GetUpn() string {
	if o == nil || IsNil(o.Upn.Get()) {
		var ret string
		return ret
	}
	return *o.Upn.Get()
}

// GetUpnOk returns a tuple with the Upn field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *IdentityInfo) GetUpnOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Upn.Get(), o.Upn.IsSet()
}

// HasUpn returns a boolean if a field has been set.
func (o *IdentityInfo) HasUpn() bool {
	if o != nil && o.Upn.IsSet() {
		return true
	}

	return false
}

// SetUpn gets a reference to the given NullableString and assigns it to the Upn field.
func (o *IdentityInfo) SetUpn(v string) {
	o.Upn.Set(&v)
}

// SetUpnNil sets the value for Upn to be an explicit nil
func (o *IdentityInfo) SetUpnNil() {
	o.Upn.Set(nil)
}

// UnsetUpn ensures that no value is present for Upn, not even an explicit nil
func (o *IdentityInfo) UnsetUpn() {
	o.Upn.Unset()
}

// GetDisplayName returns the DisplayName field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *IdentityInfo) GetDisplayName() string {
	if o == nil || IsNil(o.DisplayName.Get()) {
		var ret string
		return ret
	}
	return *o.DisplayName.Get()
}

// GetDisplayNameOk returns a tuple with the DisplayName field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *IdentityInfo) GetDisplayNameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.DisplayName.Get(), o.DisplayName.IsSet()
}

// HasDisplayName returns a boolean if a field has been set.
func (o *IdentityInfo) HasDisplayName() bool {
	if o != nil && o.DisplayName.IsSet() {
		return true
	}

	return false
}

// SetDisplayName gets a reference to the given NullableString and assigns it to the DisplayName field.
func (o *IdentityInfo) SetDisplayName(v string) {
	o.DisplayName.Set(&v)
}

// SetDisplayNameNil sets the value for DisplayName to be an explicit nil
func (o *IdentityInfo) SetDisplayNameNil() {
	o.DisplayName.Set(nil)
}

// UnsetDisplayName ensures that no value is present for DisplayName, not even an explicit nil
func (o *IdentityInfo) UnsetDisplayName() {
	o.DisplayName.Unset()
}

// GetPersonId returns the PersonId field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *IdentityInfo) GetPersonId() string {
	if o == nil || IsNil(o.PersonId.Get()) {
		var ret string
		return ret
	}
	return *o.PersonId.Get()
}

// GetPersonIdOk returns a tuple with the PersonId field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *IdentityInfo) GetPersonIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.PersonId.Get(), o.PersonId.IsSet()
}

// HasPersonId returns a boolean if a field has been set.
func (o *IdentityInfo) HasPersonId() bool {
	if o != nil && o.PersonId.IsSet() {
		return true
	}

	return false
}

// SetPersonId gets a reference to the given NullableString and assigns it to the PersonId field.
func (o *IdentityInfo) SetPersonId(v string) {
	o.PersonId.Set(&v)
}

// SetPersonIdNil sets the value for PersonId to be an explicit nil
func (o *IdentityInfo) SetPersonIdNil() {
	o.PersonId.Set(nil)
}

// UnsetPersonId ensures that no value is present for PersonId, not even an explicit nil
func (o *IdentityInfo) UnsetPersonId() {
	o.PersonId.Unset()
}

// GetSource returns the Source field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *IdentityInfo) GetSource() string {
	if o == nil || IsNil(o.Source.Get()) {
		var ret string
		return ret
	}
	return *o.Source.Get()
}

// GetSourceOk returns a tuple with the Source field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *IdentityInfo) GetSourceOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Source.Get(), o.Source.IsSet()
}

// HasSource returns a boolean if a field has been set.
func (o *IdentityInfo) HasSource() bool {
	if o != nil && o.Source.IsSet() {
		return true
	}

	return false
}

// SetSource gets a reference to the given NullableString and assigns it to the Source field.
func (o *IdentityInfo) SetSource(v string) {
	o.Source.Set(&v)
}

// SetSourceNil sets the value for Source to be an explicit nil
func (o *IdentityInfo) SetSourceNil() {
	o.Source.Set(nil)
}

// UnsetSource ensures that no value is present for Source, not even an explicit nil
func (o *IdentityInfo) UnsetSource() {
	o.Source.Unset()
}

func (o IdentityInfo) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o IdentityInfo) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if o.Id.IsSet() {
		toSerialize["id"] = o.Id.Get()
	}
	if !IsNil(o.Type) {
		toSerialize["type"] = o.Type
	}
	if o.Upn.IsSet() {
		toSerialize["upn"] = o.Upn.Get()
	}
	if o.DisplayName.IsSet() {
		toSerialize["displayName"] = o.DisplayName.Get()
	}
	if o.PersonId.IsSet() {
		toSerialize["personId"] = o.PersonId.Get()
	}
	if o.Source.IsSet() {
		toSerialize["source"] = o.Source.Get()
	}
	return toSerialize, nil
}

type NullableIdentityInfo struct {
	value *IdentityInfo
	isSet bool
}

func (v NullableIdentityInfo) Get() *IdentityInfo {
	return v.value
}

func (v *NullableIdentityInfo) Set(val *IdentityInfo) {
	v.value = val
	v.isSet = true
}

func (v NullableIdentityInfo) IsSet() bool {
	return v.isSet
}

func (v *NullableIdentityInfo) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableIdentityInfo(val *IdentityInfo) *NullableIdentityInfo {
	return &NullableIdentityInfo{value: val, isSet: true}
}

func (v NullableIdentityInfo) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableIdentityInfo) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
